Index: trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp	(revision 23997)
+++ trunk/src/VBox/Frontends/VBoxHeadless/VBoxHeadless.cpp	(revision 23998)
@@ -116,4 +116,5 @@
         refcnt = 0;
 #endif
+        mLastVRDPPort = -1;
     }
 
@@ -210,8 +211,15 @@
                 LONG port;
                 info->COMGETTER(Port)(&port);
-                if (port != 0)
-                    RTPrintf("Listening on port %d\n", port);
-                else
-                    RTPrintf("VRDP server failed to start\n");
+                if (port != mLastVRDPPort)
+                {
+                    if (port == -1)
+                        RTPrintf("VRDP server is inactive.\n");
+                    else if (port == 0)
+                        RTPrintf("VRDP server failed to start.\n");
+                    else
+                        RTPrintf("Listening on port %d.\n", port);
+
+                    mLastVRDPPort = port;
+                }
             }
         }
@@ -276,4 +284,5 @@
     long refcnt;
 #endif
+    long mLastVRDPPort;
 };
 
@@ -351,6 +360,7 @@
              "   -v, -vrdp, --vrdp on|off|config       Enable (default) or disable the VRDP\n"
              "                                         server or don't change the setting\n"
-             "   -p, -vrdpport, --vrdpport <port>      Port number the VRDP server will bind\n"
-             "                                         to\n"
+             "   -p, -vrdpport, --vrdpport <ports>     Comma-separated list of ports the VRDP\n"
+             "                                         server can bind to. Use a dash between\n"
+             "                                         two port numbers to specify a range\n"
              "   -a, -vrdpaddress, --vrdpaddress <ip>  Interface IP the VRDP will bind to \n"
 #endif
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp	(revision 23997)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp	(revision 23998)
@@ -225,5 +225,5 @@
         {
             RTPrintf("                            [--vrdp on|off]\n"
-                     "                            [--vrdpport default|<port>]\n"
+                     "                            [--vrdpport default|<ports>]\n"
                      "                            [--vrdpaddress <host>]\n"
                      "                            [--vrdpauthtype null|external|guest]\n"
@@ -298,6 +298,6 @@
         if (fVRDP)
         {
-            RTPrintf("                            vrdp on|off] |\n");
-            RTPrintf("                            vrdpport default|<port>] |\n");
+            RTPrintf("                            vrdp on|off |\n");
+            RTPrintf("                            vrdpport default|<ports> |\n");
         }
         RTPrintf("                            setvideomodehint <xres> <yres> <bpp> [display] |\n"
Index: trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 23997)
+++ trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 23998)
@@ -665,5 +665,5 @@
 #endif
 #ifdef VBOX_WITH_VRDP
-             "  --vrdp <port>            Listen for VRDP connections on port (default if not specified)\n"
+             "  --vrdp <ports>           Listen for VRDP connections on one of specified ports (default if not specified)\n"
 #endif
              "  --discardstate           Discard saved state (if present) and revert to last snapshot (if present)\n"
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDisplay.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDisplay.ui	(revision 23997)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDisplay.ui	(revision 23998)
@@ -288,5 +288,5 @@
               <widget class="QLineEdit" name="mLeVRDPPort">
                <property name="whatsThis">
-                <string>Displays the VRDP Server port number. You may specify &lt;tt&gt;0&lt;/tt&gt; (zero) to reset the port to the default value.</string>
+                <string>The VRDP Server port number. You may specify &lt;tt&gt;0&lt;/tt&gt; (zero), which means port 3389, the standard port for RDP.</string>
                </property>
               </widget>